/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package download;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.MalformedURLException;
import java.net.SocketException;
import java.net.SocketTimeoutException;
import java.net.URL;
import java.net.URLConnection;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.concurrent.CountDownLatch;
import javax.swing.JOptionPane;
import javax.swing.UIManager;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.InputSource;

public class Download
{
    public static final String _CURRENT_VERSIONS = "versiuniCurente.txt";
    public static final String _dLocal = "6";
    public static final String _newLine = System.getProperty("line.separator");
    public static String _rootPath = null;
    public static String _configPath = null;
    public static String _libPath = null;
    public static String _docPath = null;
//    private static Properties _props = null;
    public static InputStream _input = null;
    public static String _urlVersiuni = null;
    public static String _proxy = null;
    public static String _proxyIP = null;
    public static String _proxyPort = null;
    public static String _error = null;
    public static String _javaStartPrefix = null;
    public static String _javaVersion = null;
    public static String _ignoraDeclaratiiNoi = null;
    public static String _xmlFile = null;
    //structuri pt readAndParseVersiuniXml.xml
    public static int _iSite = 0;
    public static int _cSite = 0;
    public static int _sSite = 0;
    public static int _jSite = 0;
    public static int _pSite = 0;
    public static String _dSite = null;
    public static ArrayList<String> _iJars = new ArrayList<String>(10);
    public static ArrayList<String> _sJars = new ArrayList<String>(10);
    public static ArrayList<String> _zJars = new ArrayList<String>(10);
    public static ArrayList<String> _cFiles = new ArrayList<String>(10);
    public static ArrayList<String> _dJars = new ArrayList<String>(10);
    public static ArrayList<String> _docs = new ArrayList<String>(10);
    public static Decl[] _decl = null;
    //structuri pt local
    public static int _iLocal = 0;
    public static int _cLocal = 0;
    public static int _sLocal = 0;
    public static int _jLocal = 0;
    public static int _pLocal = 0;
    public static ArrayList<DownloadList> _dwn = new ArrayList<DownloadList>(10);
    public static int _panePrinc = 0;
    public static int _paneVersJP = 0;
    public static int _paneNewDec = 0;
    public static Decl[] _newVers = null;
    public static Decl[] _newDec = null;
    public static CountDownLatch _waitEvent = new CountDownLatch(1);
    public static FinalizeDownloadFrame _frame = null;
    public static boolean _continuationFlag = true;
    public static boolean _bckCreated = false;

    private static int findConfig()
    {
        int len = 0;
        String par = null;
        String parRoot = null;
        String parLib = null;
        try
        {
            //determinare configPath
            URL url = DownloadList.class.getProtectionDomain().getCodeSource().getLocation();
            try
            {
                par = url.toURI().getPath();
            }
            catch(Throwable ex)
            {
                par = url.getPath();
            }
            //atentie ar putea fi probleme pe linux
            if(par.startsWith("/") == true)
            {
                par = par.substring(1);
            }
            len = par.indexOf("Download.jar");
            if(len < 0)
            {
                parRoot = padPath(par);
                parLib = padPath(par) + "lib";
                par = padPath(par) + "config";
            }
            else
            {
                parRoot = padPath(par.substring(0, len));
                parLib = parRoot + "lib";
                par = parRoot + "config";
            }
//            System.out.println("parRoot:" + parRoot + " par:" + par + " parLib:" + parLib);
            if((new File(par)).isDirectory() == true && (new File(parLib)).isDirectory() == true)
            {
                _rootPath = parRoot;
                _configPath = padPath(par);
                _libPath = padPath(parLib);
                if((new File(_rootPath + "doc")).isDirectory() == true)
                {
                    _docPath = padPath(_rootPath + "doc");
                }
                return 0;
            }
            File root = new File("");
            File cfg = new File("config");
            File lib = new File("lib");
            File doc = new File("doc");
            if(cfg.isDirectory() == true && lib.isDirectory() == true)
            {
                try
                {
                    _rootPath = padPath(root.getCanonicalPath());
                    _configPath = padPath(cfg.getCanonicalPath());
                    _libPath = padPath(lib.getCanonicalPath());
                    if(doc.isDirectory() == true)
                    {
                        _docPath = padPath(doc.getCanonicalPath());
                    }
                    return 0;
                }
                catch(IOException ex)
                {
                }
            }
            //nu pot determina configPath
            par = "folderele config/lib nu pot fi determinate." + _newLine
                + "Reinstalati aplicatia!";
            try
            {
                JOptionPane.showMessageDialog(null,/*rootPane,*/ par);
            }
            catch(Throwable ex)
            {
                System.out.println(par);
            }
        }
        catch(Throwable ex)
        {
        }
        return -1;
    }

    private static String padPath(String path)
    {
        if(path.endsWith("/") == false && path.endsWith("\\") == false)
        {
            return path + File.separator;
        }
        return path;
    }

    private static String getDeclarationList()
    {
        String fileName = _configPath + _CURRENT_VERSIONS;
        BufferedReader str = null;
        String line = null;
        String[] cmp = null;
        ArrayList<String> list = new ArrayList<String>(10);
        try
        {
            str = new BufferedReader(new FileReader(fileName));
            line = str.readLine();
            cmp = line.split("\\.");
            if(cmp.length != 5)
            {
                str.close();
                return "eroare structura versiune local";
            }
            try
            {
                _iLocal = Integer.parseInt(cmp[0]);
                _cLocal = Integer.parseInt(cmp[1]);
                _sLocal = Integer.parseInt(cmp[2]);
                _jLocal = Integer.parseInt(cmp[3]);
                _pLocal = Integer.parseInt(cmp[4]);
            }
            catch(Throwable ex)
            {
                str.close();
                return "eroare structura versiune local";
            }
            int i = 0;
            Decl entry = new Decl();
            while(true)
            {
                line = str.readLine();
                if(line == null)
                {
                    break;
                }
                cmp = line.split(";");
                entry._decType = cmp[0];
                i = Arrays.binarySearch(_decl, entry);
                if(i < 0)
                {
                    continue;
                }
                _decl[i]._jLocalVers = cmp[1];
                _decl[i]._pLocalVers = cmp[2];
            }
            str.close();
        }
        catch(Throwable ex)
        {
            return ex.toString();
        }
        return null;
    }

    private static void getConfigDefaults()
    {
        if(_configPath.equals("") == true)
        {
            return;
        }
        try
        {
//            _props = new Properties();
//            FileInputStream file = new FileInputStream(_configPath + "config.properties");
//            _props.load(file);
//            file.close();
            Params.init(_configPath + "config.properties");
            _urlVersiuni = Params.getProperty("urlVersiuni");
            _proxy = Params.getProperty("proxy");
            _proxyIP = Params.getProperty("proxyIP");
            _proxyPort = Params.getProperty("proxyPort");
            _javaStartPrefix = Params.getProperty("javaStartPrefix");
            if(_javaStartPrefix == null || _javaStartPrefix.equals("") == true)
            {
                _javaStartPrefix = "java";
            }
            _javaVersion = Params.getProperty("javaVersion");
            if(_javaVersion != null && _javaVersion.equals("") == true)
            {
                _javaVersion = "-version:"
                    + System.getProperty("java.specification.version");
            }
            _ignoraDeclaratiiNoi = Params.getProperty("ignoraDeclaratiiNoi");
            if(_ignoraDeclaratiiNoi == null || _ignoraDeclaratiiNoi.equals("") == true)
            {
                _ignoraDeclaratiiNoi = "N";
            }
        }
        //catch exception in case properties file does not exist
        catch(Throwable e)
        {
            return;
        }
    }

    public static String readAndParseVersiuniXml(String url, String proxy, String proxyIP, String proxyPort)
    {
//        URL hp = null;
//        URLConnection hpCon = null;
//        InputStream input = null;
        DocumentBuilderFactory dbf = null;
        DocumentBuilder db = null;
        Document doc = null;

        try
        {
            DownloadWaitFrame frame = new DownloadWaitFrame(url, proxy, proxyIP, proxyPort);
            frame.setVisible(true);
            _waitEvent.await();
            _waitEvent = new CountDownLatch(1);
            if(_error != null)
            {
                return _error;
            }
        }
        catch(Throwable e)
        {
            return e.toString();
        }
        if(_error != null)
        {
            return _error;
        }
//        try
//        {
//            hp = new URL(url);
//        }
//        catch(MalformedURLException e)
//        {
//            return e.toString();
//        }
//        catch(Throwable e)
//        {
//            return e.toString();
//        }
//        try
//        {
////            URL hp = new URL("http://static.anaf.ro/static/10/Anaf/declunica/readAndParseVersiuniXml.xml");
//            if(proxy != null && proxy.equals("auto"))
//            {
//                System.setProperty("java.net.useSystemProxies", "true");
//            }
//            hpCon = hp.openConnection();
//            _input = hpCon.getInputStream();
//        }
//        catch(Throwable e)
//        {
//            try
//            {
//                if(proxyIP == null)
//                {
//                    return "Incercati introducerea proxyIP/proxyPort in fisierul config/config.properties";
//                }
//                System.setProperty("http.proxyHost", proxyIP);
//                System.setProperty("http.proxyPort", (proxyPort == null) ? "80" : proxyPort);
//                hpCon = hp.openConnection();
//                _input = hpCon.getInputStream();
//            }
//            catch(Throwable ex)
//            {
//                return ex.toString();
//            }
//        }
        try
        {
            dbf = DocumentBuilderFactory.newInstance();
            db = dbf.newDocumentBuilder();
            doc = db.parse(new InputSource(_input));
            Element root = doc.getDocumentElement();
            Element jars = null;
            NodeList jarsURL = null;
            int cnt = 0;
            //obtine readAndParseVersiuniXml site
            String txt = ((Element)root.getElementsByTagName("versiune").item(0)).getTextContent();
            String[] cmp = txt.split("\\.");
            if(cmp.length != 5)
            {
                return "eroare structura versiune";
            }
            try
            {
                _iSite = Integer.parseInt(cmp[0]);
                _cSite = Integer.parseInt(cmp[1]);
                _sSite = Integer.parseInt(cmp[2]);
                _jSite = Integer.parseInt(cmp[3]);
                _pSite = Integer.parseInt(cmp[4]);
            }
            catch(Throwable ex)
            {
                return "eroare structura versiune";
            }
            _dSite = ((Element)root.getElementsByTagName("versiuneDownload").item(0)).getTextContent();
            //obtine lista de dJars
            jars = (Element)root.getElementsByTagName("dJars").item(0);
            jarsURL = jars.getElementsByTagName("jarURL");
            cnt = jarsURL.getLength();
            if(cnt <= 0)
            {
                return "lipsa dJars";
            }
            for(int i = 0; i < cnt; i++)
            {
                _dJars.add(jarsURL.item(i).getFirstChild().getNodeValue());
            }
            //obtine lista de iJars
            jars = (Element)root.getElementsByTagName("iJars").item(0);
            jarsURL = jars.getElementsByTagName("jarURL");
            cnt = jarsURL.getLength();
            if(cnt <= 0)
            {
                return "lipsa iJars";
            }
            for(int i = 0; i < cnt; i++)
            {
                _iJars.add(jarsURL.item(i).getFirstChild().getNodeValue());
            }
            //obtine lista de sJars
            jars = (Element)root.getElementsByTagName("sJars").item(0);
            jarsURL = jars.getElementsByTagName("jarURL");
            cnt = jarsURL.getLength();
            if(cnt <= 0)
            {
                return "lipsa sJars";
            }
            for(int i = 0; i < cnt; i++)
            {
                _sJars.add(jarsURL.item(i).getFirstChild().getNodeValue());
            }
            //obtine lista de zJars
            jars = (Element)root.getElementsByTagName("zJars").item(0);
            jarsURL = jars.getElementsByTagName("jarURL");
            cnt = jarsURL.getLength();
            if(cnt <= 0)
            {
                return "lipsa zJars";
            }
            for(int i = 0; i < cnt; i++)
            {
                _zJars.add(jarsURL.item(i).getFirstChild().getNodeValue());
            }
            //obtine lista de cFisiere
            jars = (Element)root.getElementsByTagName("cFisiere").item(0);
            jarsURL = jars.getElementsByTagName("fisierURL");
            cnt = jarsURL.getLength();
            if(cnt <= 0)
            {
                return "lipsa cFisiere";
            }
            for(int i = 0; i < cnt; i++)
            {
                _cFiles.add(jarsURL.item(i).getFirstChild().getNodeValue());
            }
            //obtine lista de fisiere documentatie
            jars = (Element)root.getElementsByTagName("documentatie").item(0);
            jarsURL = jars.getElementsByTagName("docURL");
            cnt = jarsURL.getLength();
//            if(cnt <= 0)
//            {
//                return "lipsa documentatie";
//            }
            for(int i = 0; i < cnt; i++)
            {
                _docs.add(jarsURL.item(i).getFirstChild().getNodeValue());
            }
            //parsare declaratii
            ArrayList<Decl> decList = new ArrayList<Decl>(10);
            jars = (Element)root.getElementsByTagName("declaratii").item(0);
            jarsURL = jars.getChildNodes();
            cnt = jarsURL.getLength();
            Decl decl = null;
            for(int i = 0; i < cnt; i++)
            {
                if(jarsURL.item(i).getNodeType() != Node.ELEMENT_NODE)
                {
                    continue;
                }
                decl = new Decl();
                jars = (Element)jarsURL.item(i);
                decl._decType = jars.getTagName();
                decl._jSiteVers = jars.getElementsByTagName("versiuneJ").item(0).getFirstChild().getNodeValue();
                decl._pSiteVers = jars.getElementsByTagName("versiuneP").item(0).getFirstChild().getNodeValue();
                decl._jURL = jars.getElementsByTagName("JURL").item(0).getFirstChild().getNodeValue();
                decl._pURL = jars.getElementsByTagName("PURL").item(0).getFirstChild().getNodeValue();
                decl._dURL = jars.getElementsByTagName("DURL").item(0).getFirstChild().getNodeValue();
                decl._jLocalVers = null;
                decl._pLocalVers = null;
                decList.add(decl);
            }
            cnt = decList.size();
            if(cnt <= 0)
            {
                return "lipsa declaratii";
            }
            _decl = decList.toArray(new Decl[cnt]);
            Arrays.sort(_decl);
            _input.close();
        }
        catch(SocketException e)
        {
            return e.toString();
        }
        catch(SocketTimeoutException e)
        {
            return e.toString();
        }
        catch(Throwable e)
        {
            return e.toString();
        }
        return null;
    }

    //downloadeaza un fisier
    public static int inputToFile(InputStream input, String locatie)
    {
        File f = new File(locatie);
        OutputStream out = null;
        int read = 0;
        byte[] bytes = new byte[1024];

        try
        {
            out = new FileOutputStream(f);
            while((read = input.read(bytes)) != -1)
            {
                out.write(bytes, 0, read);
            }
            input.close();
            out.flush();
            out.close();
        }
        catch(Throwable ex)
        {
            return -1;
        }
        return 0;
    }

    //download un fisier
    public static String download(String url, String fisier)
    {
        try
        {
            URL hpsoft = new URL(url);
            URLConnection hpConsoft = hpsoft.openConnection();
            InputStream inputsoft = hpConsoft.getInputStream();
            File file = new File(fisier);
            if(file.exists() == true)
            {
                file.delete();
            }
            inputToFile(inputsoft, fisier);
        }
        catch(Throwable e)
        {
            return e.toString();
        }
        return null;
    }

    //download colectie fisiere
    public static String downloadAll()
    {
        String rez = null;
        int level = 0;
        try
        {
            for(DownloadList dwn : _dwn)
            {
                rez = download(dwn._url, dwn._dest + (((dwn._status & 1) == 0) ? ".new" : ""));
                if(rez != null)
                {
                    return rez;
                }
                dwn._status |= 2;
                _frame.advanceProgressBar(level, dwn._dest);
                level++;
            }
        }
        catch(Throwable ex)
        {
            return ex.toString();
        }
        return null;
    }

    //finalizare download: instalare noi fisiere
    public static String finalizeDownload()
    {
        File fileOld = null;
        File fileNew = null;
        boolean flag = true;
        try
        {
            for(DownloadList dwn : _dwn)
            {
                if((dwn._status & 9) != 0)
                {
                    continue;
                }
                fileOld = new File(dwn._dest);
//                System.out.println("dest:" + dwn._dest);
                if(fileOld.exists() == true)
                {
                    if((dwn._status & 4) != 0)
                    {
                        fileNew = new File(dwn._dest + ".bck");
                        if(fileNew.exists() == true)
                        {
                            fileNew.delete();
                        }
                        fileOld.renameTo(fileNew);
                        _bckCreated = true;
                    }
                    else
                    {
                        fileOld.delete();
                    }
                }
                fileNew = new File(dwn._dest + ".new");
                if(fileNew.exists() == true)
                {
                    flag = fileNew.renameTo(new File(dwn._dest));
                    if(flag == false)
                    {
                        return "fisierul " + dwn._dest + _newLine + " nu a putut fi inlocuit cu versiunea noua";
                    }
                }
                else
                {
                    return "fisierul " + dwn._dest + ".new nu a fost gasit";
                }
            }
        }
        catch(Throwable ex)
        {
            return ex.toString();
        }
        return null;
    }

    //sterge fisiere downloadate in caz de esec download
    public static String undoDownload()
    {
        File file = null;
        try
        {
            for(DownloadList dwn : _dwn)
            {
                if((dwn._status & 2) == 0)
                {
                    continue;
                }
                file = new File(dwn._dest + ".new");
                if(file.exists() == true)
                {
                    file.delete();
                }
            }
        }
        catch(Throwable ex)
        {
            return ex.toString();
        }
        return null;
    }

    public static void deleteCurrentVersionsFile()
    {
        try
        {
            File file = new File(_configPath + _CURRENT_VERSIONS);
            if(file.exists() == true)
            {
                file.delete();

            }
        }
        catch(Throwable ex)
        {
        }
    }

    //analiza comparativa a versiunilor site/;ocal
    private static String analizeResults()
    {
        //analiza versiune i:
        DownloadList dwn = null;
        //analiza versiune d:
        if(_dSite.equals(_dLocal) == false)
        {
            for(String url : _dJars)
            {
                _dwn.add(new DownloadList(url, _rootPath, 8));
            }
            _panePrinc = 1;
        }
        //analiza versiune i:
        if(_iSite != _iLocal)
        {
            for(String url : _iJars)
            {
                _dwn.add(new DownloadList(url, _libPath, 0));
            }
            _panePrinc = 1;
        }
        //analiza versiune s (colectii sJars si zJars)
        if(_sSite != _sLocal)
        {
            for(String url : _sJars)
            {
                _dwn.add(new DownloadList(url, _libPath, 0));
            }
            for(String url : _zJars)
            {
                _dwn.add(new DownloadList(url, _rootPath, 0));
            }
            _panePrinc = 1;
        }
        //analiza versiune c
        if(_cSite != _cLocal)
        {
            for(String url : _cFiles)
            {
                dwn = new DownloadList(url, _configPath, 0);
                _dwn.add(dwn);
                if((new File(dwn._dest)).exists() == false)
                {
                    dwn._status |= 1;
                }
                else
                {
                    dwn._status |= 4;
                }
            }
            _panePrinc = 1;
        }
        else
        {
            for(String url : _cFiles)
            {
                dwn = new DownloadList(url, _configPath, 0);
                if((new File(dwn._dest)).exists() == false)
                {
                    dwn._status |= 1;
                    _dwn.add(dwn);
                    _panePrinc = 1;
                }
            }
        }
        //analiza versiune j si analiza versiune p
        if(_jSite != _jLocal || _pSite != _pLocal)
        {
            for(Decl decl : _decl)
            {
                if(decl._jLocalVers != null && decl._pLocalVers != null)
                {
                    if(_jSite != _jLocal)
                    {
                        _dwn.add(new DownloadList(decl._jURL, _libPath, 0));
                    }
                    if(_pSite != _pLocal)
                    {
                        _dwn.add(new DownloadList(decl._pURL, _libPath, 0));
                    }
                    if(_docPath != null)
                    {
                        _dwn.add(new DownloadList(decl._dURL, _docPath, 0));
                    }
                    _paneVersJP = 1;
                    _panePrinc = 2;
                }
            }
        }
        ArrayList<Decl> list = new ArrayList<Decl>(10);
        //compune lista de declaratii cu versiuni noi
        if(_pSite == _pLocal && _jSite == _jLocal)
        {
            for(Decl decl : _decl)
            {
                if(decl._jLocalVers != null && decl._pLocalVers != null
                    && ((decl._jLocalVers.equals(decl._jSiteVers) == false)
                    || (decl._pLocalVers.equals(decl._pSiteVers) == false)))
                {
                    list.add(decl);
                    _paneVersJP++;
                }
            }
            if(_paneVersJP != 0)
            {
                _newVers = list.toArray(new Decl[0]);
            }
        }
        //compune lista de declaratii noi
        list.clear();
        for(Decl decl : _decl)
        {
            if(decl._jLocalVers == null || decl._pLocalVers == null)
            {
                list.add(decl);
                _paneNewDec++;
            }
        }
        if(_paneNewDec != 0)
        {
            _newDec = list.toArray(new Decl[0]);
        }
        return null;
    }

    public static boolean isUnix()
    {
        String os = System.getProperty("os.name").toLowerCase();
        //linux or unix
        return (os.indexOf("nix") >= 0 || os.indexOf("nux") >= 0);
    }

    public static void startDUKIntegrator()
    {
        try
        {
            Runtime rt = Runtime.getRuntime();
            String path = ((isUnix() == false
                && _rootPath.startsWith("/") == true
                && _rootPath.startsWith("//") == false) ? _rootPath.substring(1) : _rootPath);
            ArrayList<String> cmd = new ArrayList<String>(6);
            cmd.add(_javaStartPrefix);
            if(_javaVersion != null)
            {
                cmd.add(_javaVersion);
            }
            cmd.add("-jar");
            cmd.add(path + "DUKIntegrator.jar");
            cmd.add("-d");
            if(_xmlFile != null)
            {
                cmd.add(_xmlFile);
            }
//            String cmdLine[] =
//            {
//                _javaStartPrefix,
//                ((_javaVersion != null) ? _javaVersion : ""),
//                "-jar", path + "DUKIntegrator.jar", "-d",
//                ((_xmlFile != null) ? _xmlFile : "")
//            };
            String cmdLine[] = cmd.toArray(new String[cmd.size()]);
            Process pr = rt.exec(cmdLine);
        }
        catch(Throwable ex)
        {
            JOptionPane.showMessageDialog(null,/*rootPane,*/
                "DUKIntegrator nu a putut fi pornit" + _newLine
                + ex.toString() + _newLine
                + "Reinstalati aplicatia");
        }
    }

    public static void main(String[] args)
    {
        String text = null;
        try
        {
            UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
            if(args.length > 0)
            {
                _xmlFile = args[0];
                //cazul fisierelor cu nume continand spatii
                //  daca sunt mai multe spatii consecutive nu mai merge
//                for(int i = 1; i < args.length; i++)
//                {
//                    _xmlFile += " " + args[i];
//                }
            }
//            System.out.println("2xmlFile:" + _xmlFile);
            if(findConfig() < 0)
            {
                return;
            }
            //obtine parametri din fisierul de configurare
            getConfigDefaults();
            //verifica existenta fisier versiuniCurente.txt
            String fileName = _configPath + _CURRENT_VERSIONS;
            File versFile = new File(fileName);
            if(versFile.exists() == false)
            {
                //apel DUKIntegrator
                Runtime rt = Runtime.getRuntime();
                String path = ((isUnix() == false && _rootPath.startsWith("/") == true && _rootPath.startsWith("//") == false) ? _rootPath.substring(1) : _rootPath);
                ArrayList<String> cmd = new ArrayList<String>(5);
                cmd.add(_javaStartPrefix);
                if(_javaVersion != null)
                {
                    cmd.add(_javaVersion);
                }
                cmd.add("-jar");
                cmd.add(path + "DUKIntegrator.jar");
                cmd.add("-F");
//                String cmdLine[] =
//                {
//                    _javaStartPrefix,
//                    ((_javaVersion != null) ? _javaVersion : ""),
//                    "-jar", path + "DUKIntegrator.jar", "-F"
//                };
                String cmdLine[] = cmd.toArray(new String[cmd.size()]);
                Process pr = rt.exec(cmdLine);
                pr.waitFor();
                //reverific existenta fisier versiuniCurente.txt
                versFile = new File(fileName);
                if(versFile.exists() == false)
                {
                    String par = "Nu pot crea fisierul " + fileName + _newLine
                        + "Reinstalati aplicatia!";
                    JOptionPane.showMessageDialog(null,/*rootPane,*/ par);
                    return;
                }
            }
            //verifica existenta conexiune
            if(_urlVersiuni != null)
            {
                //citeste fisier readAndParseVersiuniXml.xml de pe internet
                text = readAndParseVersiuniXml(_urlVersiuni, _proxy, _proxyIP, _proxyPort);
                if(text != null)
                {
                    JOptionPane.showMessageDialog(null, "Eroare conectare la Internet sau adresa web (din config.properties) incorecta:"
                        + _newLine + text);
                }
                else
                {
                    //citire informatii declaratii instalate
                    text = getDeclarationList();
                    if(text != null)
                    {
                        JOptionPane.showMessageDialog(null, "Eroare citire tipuri declaratii instalate:"
                            + _newLine + text);
                    }
                    else
                    {
                        //analiza rezultate
                        text = analizeResults();
                        if(_dwn.size() != 0
                            || (_newVers != null && _newVers.length != 0)
                            || (_newDec != null && _newDec.length != 0
                            && _ignoraDeclaratiiNoi.equals("D") == false))
                        {
                            DownloadFrame frame = new DownloadFrame();
                            frame.setVisible(true);
                            _waitEvent.await();
                        }
                    }
                }
            }
            if(_continuationFlag == true)
            {
                startDUKIntegrator();
            }
        }
        catch(Throwable ex)
        {
            return;
        }
    }

    public static class Decl implements Comparable
    {
        public String _decType;
        public String _jSiteVers;
        public String _jURL;
        public String _jLocalVers;
        public String _pSiteVers;
        public String _pURL;
        public String _pLocalVers;
        public String _dURL;

        public int compareTo(Object o)
        {
            return _decType.compareTo(((Decl)o)._decType);
        }

        public String toString()
        {
            return _decType + " versiune Validator: " + _jSiteVers + " versiune PDF: " + _pSiteVers;
        }
    }

    public static class DownloadList
    {
        public String _url;
        public String _dest;
        //bit0 (1) = 1 - fisierul downloadat se salveaza cu numele <_dest>;
        //bit0 (1) = 0 - fisierul downloadat se salveaza cu numele <_dest>.new
        //bit1 (2) = 1 - fisierul a fost downloadat cu succes
        //bit1 (2) = 0 - fisierul nu a fost inca downloadat sau au aparut erori
        //bit2 (4) = 1 - fisier de configurare; trebuie pastrata o copie
        //  cu numele <_dest>.bck
        //bit2 (4) = 0 - fisier comun (jar); nu se pastreaza nici o copie
        //bit3 (8) = 1 - nu se face finalizare download la acest fisier
        //bit3 (8) = 0 - se face finalizare download la acest fisier
        public int _status;

        public DownloadList(String url, String path, int status)
        {
            _url = url;
            _dest = path + url.substring(url.lastIndexOf("/") + 1);
            _status = status;
        }
    }
}
